#include "../src/stm/wlpdstm.h"

//////////////////
// start/end tx //
//////////////////

#define BEGIN_TRANSACTION           \
	while(true) {                   \
		try {                       \
			wlpdstm::start_tx()

// body goes in the middle

#define END_TRANSACTION                         \
			wlpdstm::commit_tx();               \
			break;                              \
		} catch (wlpdstm::RestartedException) { \
			/* do nothing */                    \
        } catch (wlpdstm::AbortedException) {   \
            throw;                              \
        }                                       \
    }


////////////////////////////////////////////
// start/end transaction and count aborts //
////////////////////////////////////////////

#define BEGIN_TRANSACTION_CA        \
	while(true) {                   \
		try {                       \
			wlpdstm::start_tx()

// body goes in the middle

#define END_TRANSACTION_CA                      \
			wlpdstm::commit_tx();               \
			break;                              \
		} catch (wlpdstm::RestartedException) { \
			aborts++;                           \
        } catch (wlpdstm::AbortedException) {   \
        	aborts++;                           \
            throw;                              \
        }                                       \
    }
